package com.mycompany.controlpanelmvn;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Level;
import java.util.logging.Logger;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.SQLException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;


/**
 *
 * @author conforti
 */
public class MainFrame extends javax.swing.JFrame {

    protected Redis myRedis;

    protected db myDB; 
    
    private Process xtermProcess = null;
    
    // archive parameters
    protected boolean archiveActive; 
    protected String host;
    protected String username;
    protected String password; 
    protected String remote_path; 
    protected String port; 
    protected String connection; // FTP / SSH 
    
    
    
    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        initComponents();
        initialize(); 

    }
    //TODO investigate how to close software and release the resources

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane = new javax.swing.JScrollPane();
        jPanel = new javax.swing.JPanel();
        projectConfigurationPane = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        l_protocol = new javax.swing.JLabel();
        l_archiver = new javax.swing.JLabel();
        l_provider = new javax.swing.JLabel();
        l_packet = new javax.swing.JLabel();
        l_monitor = new javax.swing.JLabel();
        lab_protocol = new javax.swing.JLabel();
        lab_archiver = new javax.swing.JLabel();
        lab_provider = new javax.swing.JLabel();
        lab_packet = new javax.swing.JLabel();
        lab_monitor = new javax.swing.JLabel();
        l_rate_interval = new javax.swing.JLabel();
        lab_rateinterval = new javax.swing.JLabel();
        observationConfigurationPane1 = new javax.swing.JPanel();
        lab_daq_id = new javax.swing.JLabel();
        val_daq_id = new javax.swing.JTextField();
        b_set_daqid = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        l_date = new javax.swing.JLabel();
        l_targetid = new javax.swing.JLabel();
        l_obsmode = new javax.swing.JLabel();
        l_telid = new javax.swing.JLabel();
        r_runid = new javax.swing.JLabel();
        lab_date = new javax.swing.JLabel();
        lab_targetid = new javax.swing.JLabel();
        lab_obsmode = new javax.swing.JLabel();
        lab_telid = new javax.swing.JLabel();
        lab_runid = new javax.swing.JLabel();
        val_date = new javax.swing.JTextField();
        val_targetid = new javax.swing.JTextField();
        val_obsmode = new javax.swing.JTextField();
        val_telid = new javax.swing.JTextField();
        val_runid = new javax.swing.JTextField();
        b_set_configuration = new javax.swing.JButton();
        jSeparator4 = new javax.swing.JSeparator();
        commandsPane = new javax.swing.JPanel();
        b_stop_proc = new javax.swing.JButton();
        b_start_proc = new javax.swing.JButton();
        b_stop_daq = new javax.swing.JButton();
        b_start_daq = new javax.swing.JButton();
        b_start_all = new javax.swing.JButton();
        b_stop_all = new javax.swing.JButton();
        runningObservationPane = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel27 = new javax.swing.JLabel();
        lab_c11_count = new javax.swing.JLabel();
        lab_c11_lost = new javax.swing.JLabel();
        lab_not_count = new javax.swing.JLabel();
        lab_vlg_count = new javax.swing.JLabel();
        lab_hk_count = new javax.swing.JLabel();
        lab_hvg_count = new javax.swing.JLabel();
        lab_c14_count = new javax.swing.JLabel();
        lab_s22_count = new javax.swing.JLabel();
        lab_s22_lost = new javax.swing.JLabel();
        lab_hvg_lost = new javax.swing.JLabel();
        lab_vlg_lost = new javax.swing.JLabel();
        lab_c14_lost = new javax.swing.JLabel();
        lab_not_lost = new javax.swing.JLabel();
        lab_hk_lost = new javax.swing.JLabel();
        jLabel48 = new javax.swing.JLabel();
        jLabel52 = new javax.swing.JLabel();
        jLabel53 = new javax.swing.JLabel();
        jLabel54 = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        jLabel56 = new javax.swing.JLabel();
        l_status = new javax.swing.JLabel();
        lab_status = new javax.swing.JLabel();
        l_mode = new javax.swing.JLabel();
        lab_mode = new javax.swing.JLabel();
        l_tot_count = new javax.swing.JLabel();
        lab_tot_count = new javax.swing.JLabel();
        l_totl_lost = new javax.swing.JLabel();
        lab_tot_lost = new javax.swing.JLabel();
        l_rate = new javax.swing.JLabel();
        l_avg = new javax.swing.JLabel();
        lab_rate = new javax.swing.JLabel();
        lab_avg = new javax.swing.JLabel();
        l_file = new javax.swing.JLabel();
        lab_file = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        Logo = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Control Panel");
        setBackground(new java.awt.Color(102, 102, 102));

        jPanel.setBackground(new java.awt.Color(255, 255, 255));
        jPanel.setPreferredSize(new java.awt.Dimension(784, 830));

        projectConfigurationPane.setBackground(new java.awt.Color(255, 255, 204));
        projectConfigurationPane.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel9.setFont(new java.awt.Font("Cantarell", 1, 24)); // NOI18N
        jLabel9.setText("Project Configuration");

        l_protocol.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_protocol.setText("protocol");

        l_archiver.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_archiver.setText("archiver");

        l_provider.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_provider.setText("provider");

        l_packet.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_packet.setText("packet");

        l_monitor.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_monitor.setText("monitor");

        lab_protocol.setText(" - - - ");
        lab_protocol.setToolTipText("<html>\ntcp: TCP/IP <br>\nUDP: UDP connection <br>\nfile: to get simulated files <br>\n</html>");
        lab_protocol.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_archiver.setText(" - - - ");
        lab_archiver.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_provider.setText(" - - - ");
        lab_provider.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_packet.setText(" - - - ");
        lab_packet.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_monitor.setText(" - - - ");
        lab_monitor.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_rate_interval.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_rate_interval.setText("rate interval");

        lab_rateinterval.setText(" - - - ");
        lab_rateinterval.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        javax.swing.GroupLayout projectConfigurationPaneLayout = new javax.swing.GroupLayout(projectConfigurationPane);
        projectConfigurationPane.setLayout(projectConfigurationPaneLayout);
        projectConfigurationPaneLayout.setHorizontalGroup(
            projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(projectConfigurationPaneLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 252, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(projectConfigurationPaneLayout.createSequentialGroup()
                        .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(l_protocol)
                            .addComponent(l_archiver)
                            .addComponent(l_provider)
                            .addComponent(l_packet)
                            .addComponent(l_monitor))
                        .addGap(51, 51, 51)
                        .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lab_protocol, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lab_archiver, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lab_provider, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lab_packet, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lab_monitor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(projectConfigurationPaneLayout.createSequentialGroup()
                        .addComponent(l_rate_interval)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(lab_rateinterval, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(33, Short.MAX_VALUE))
        );
        projectConfigurationPaneLayout.setVerticalGroup(
            projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, projectConfigurationPaneLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel9)
                .addGap(18, 18, 18)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_protocol)
                    .addComponent(lab_protocol))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_archiver)
                    .addComponent(lab_archiver))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_provider)
                    .addComponent(lab_provider))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_packet)
                    .addComponent(lab_packet))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_monitor)
                    .addComponent(lab_monitor))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(projectConfigurationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(l_rate_interval)
                    .addComponent(lab_rateinterval))
                .addContainerGap())
        );

        observationConfigurationPane1.setBackground(new java.awt.Color(255, 255, 204));
        observationConfigurationPane1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        lab_daq_id.setText(" - - - ");
        lab_daq_id.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        lab_daq_id.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                lab_daq_iddaq_id_initialize(evt);
            }
        });

        val_daq_id.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        val_daq_id.setText("---");
        val_daq_id.setAutoscrolls(false);
        val_daq_id.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                val_daq_idActionPerformed(evt);
            }
        });

        b_set_daqid.setText("set daq id");
        b_set_daqid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_set_daqidActionPerformed(evt);
            }
        });

        jLabel7.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        jLabel7.setText("daq id");

        jLabel8.setFont(new java.awt.Font("Cantarell", 1, 24)); // NOI18N
        jLabel8.setText("Observation Configuration");

        l_date.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_date.setText("date");

        l_targetid.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_targetid.setText("target id");

        l_obsmode.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_obsmode.setText("obs mode");

        l_telid.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_telid.setText("tel id");

        r_runid.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        r_runid.setText("run id");

        lab_date.setText(" - - - ");
        lab_date.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_targetid.setText(" - - - ");
        lab_targetid.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_obsmode.setText(" - - - ");
        lab_obsmode.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_telid.setText(" - - - ");
        lab_telid.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_runid.setText(" - - - ");
        lab_runid.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        val_date.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                val_dateActionPerformed(evt);
            }
        });

        val_runid.setAutoscrolls(false);

        b_set_configuration.setText("<html>\nSet Next <br>\nObs.<br>\nConfig. <br>\n</html>");
        b_set_configuration.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_set_configurationActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout observationConfigurationPane1Layout = new javax.swing.GroupLayout(observationConfigurationPane1);
        observationConfigurationPane1.setLayout(observationConfigurationPane1Layout);
        observationConfigurationPane1Layout.setHorizontalGroup(
            observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(observationConfigurationPane1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator4, javax.swing.GroupLayout.PREFERRED_SIZE, 378, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(observationConfigurationPane1Layout.createSequentialGroup()
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(l_obsmode, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(l_date, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(l_targetid, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addComponent(l_telid, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(r_runid, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(lab_telid, javax.swing.GroupLayout.DEFAULT_SIZE, 70, Short.MAX_VALUE)
                            .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(lab_targetid, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(lab_date, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(lab_obsmode, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 69, Short.MAX_VALUE))
                            .addComponent(lab_daq_id, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lab_runid, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(31, 31, 31)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(val_date)
                            .addComponent(val_targetid)
                            .addComponent(val_obsmode)
                            .addComponent(val_telid)
                            .addComponent(val_runid)
                            .addComponent(val_daq_id, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(b_set_daqid, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(b_set_configuration)))
                    .addComponent(jLabel8))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        observationConfigurationPane1Layout.setVerticalGroup(
            observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(observationConfigurationPane1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(lab_daq_id)
                    .addComponent(val_daq_id, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(b_set_daqid))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator4, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(observationConfigurationPane1Layout.createSequentialGroup()
                        .addGap(2, 2, 2)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(l_date)
                            .addComponent(lab_date)
                            .addComponent(val_date, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(l_targetid)
                            .addComponent(lab_targetid)
                            .addComponent(val_targetid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(l_obsmode)
                            .addComponent(lab_obsmode)
                            .addComponent(val_obsmode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(l_telid)
                            .addComponent(lab_telid)
                            .addComponent(val_telid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(observationConfigurationPane1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(r_runid)
                            .addComponent(lab_runid)
                            .addComponent(val_runid, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(observationConfigurationPane1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(b_set_configuration)
                        .addContainerGap())))
        );

        commandsPane.setBackground(new java.awt.Color(153, 204, 255));
        commandsPane.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        b_stop_proc.setText("STOP");
        b_stop_proc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_stop_procActionPerformed(evt);
            }
        });

        b_start_proc.setText("START PROCESSORS");
        b_start_proc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_start_procActionPerformed(evt);
            }
        });

        b_stop_daq.setText("STOP");
        b_stop_daq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_stop_daqActionPerformed(evt);
            }
        });

        b_start_daq.setText("START ONLY DAQ");
        b_start_daq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_start_daqActionPerformed(evt);
            }
        });

        b_start_all.setText("START ALL ");
        b_start_all.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_start_allActionPerformed(evt);
            }
        });

        b_stop_all.setText("STOP ALL");
        b_stop_all.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                b_stop_allActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout commandsPaneLayout = new javax.swing.GroupLayout(commandsPane);
        commandsPane.setLayout(commandsPaneLayout);
        commandsPaneLayout.setHorizontalGroup(
            commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(commandsPaneLayout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(b_start_proc, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(b_start_daq, javax.swing.GroupLayout.PREFERRED_SIZE, 198, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(b_stop_proc)
                    .addComponent(b_stop_daq))
                .addGap(48, 48, 48)
                .addComponent(b_start_all, javax.swing.GroupLayout.PREFERRED_SIZE, 179, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(b_stop_all, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        commandsPaneLayout.setVerticalGroup(
            commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(commandsPaneLayout.createSequentialGroup()
                .addGroup(commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(commandsPaneLayout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addGroup(commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(b_start_daq)
                            .addComponent(b_stop_daq))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(commandsPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(b_stop_proc)
                            .addComponent(b_start_proc)))
                    .addGroup(commandsPaneLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(b_start_all, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE))
                    .addGroup(commandsPaneLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(b_stop_all, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(17, Short.MAX_VALUE))
        );

        runningObservationPane.setBackground(new java.awt.Color(255, 204, 204));
        runningObservationPane.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jLabel17.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel17.setText("C11");

        jLabel20.setFont(new java.awt.Font("Segoe UI", 1, 14)); // NOI18N
        jLabel20.setText("PACKET LOST");

        jLabel27.setFont(new java.awt.Font("Segoe UI", 1, 14)); // NOI18N
        jLabel27.setText("PACKET COUNT");

        lab_c11_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_c11_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_c11_count.setText("-");
        lab_c11_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_c11_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_c11_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_c11_lost.setText("-");
        lab_c11_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_not_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_not_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_not_count.setText("-");
        lab_not_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_vlg_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_vlg_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_vlg_count.setText("-");
        lab_vlg_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_hk_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_hk_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_hk_count.setText("-");
        lab_hk_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_hvg_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_hvg_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_hvg_count.setText("-");
        lab_hvg_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_c14_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_c14_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_c14_count.setText("-");
        lab_c14_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_s22_count.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_s22_count.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_s22_count.setText("-");
        lab_s22_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_s22_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_s22_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_s22_lost.setText("-");
        lab_s22_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_hvg_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_hvg_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_hvg_lost.setText("-");
        lab_hvg_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_vlg_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_vlg_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_vlg_lost.setText("-");
        lab_vlg_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_c14_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_c14_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_c14_lost.setText("-");
        lab_c14_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_not_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_not_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_not_lost.setText("-");
        lab_not_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_hk_lost.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        lab_hk_lost.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lab_hk_lost.setText("-");
        lab_hk_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel48.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel48.setText("VHG");

        jLabel52.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel52.setText("S22");

        jLabel53.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel53.setText("C14");

        jLabel54.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel54.setText("HK");

        jLabel55.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel55.setText("VLG");

        jLabel56.setBackground(new java.awt.Color(204, 204, 204));
        jLabel56.setFont(new java.awt.Font("Segoe UI", 1, 18)); // NOI18N
        jLabel56.setText("NOT");

        l_status.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_status.setText("STATUS ");

        lab_status.setText("- - - ");
        lab_status.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_mode.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_mode.setText("MODE (F|I|R)");

        lab_mode.setText("- - - ");
        lab_mode.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_tot_count.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_tot_count.setText("PACKET COUNT");

        lab_tot_count.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lab_tot_count.setText("- - - ");
        lab_tot_count.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_totl_lost.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_totl_lost.setText("PACKET LOST");

        lab_tot_lost.setText("- - - ");
        lab_tot_lost.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_rate.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_rate.setText("ACQ Mbps");

        l_avg.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_avg.setText("ACQ pkt/s");

        lab_rate.setText("- - - ");
        lab_rate.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        lab_avg.setText("- - - ");
        lab_avg.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        l_file.setFont(new java.awt.Font("Cantarell", 1, 15)); // NOI18N
        l_file.setText("Current file");

        lab_file.setText("- - - ");
        lab_file.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel6.setFont(new java.awt.Font("Cantarell", 1, 24)); // NOI18N
        jLabel6.setText("Running Observation");

        javax.swing.GroupLayout runningObservationPaneLayout = new javax.swing.GroupLayout(runningObservationPane);
        runningObservationPane.setLayout(runningObservationPaneLayout);
        runningObservationPaneLayout.setHorizontalGroup(
            runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(runningObservationPaneLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator3)
                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                .addGap(8, 8, 8)
                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(l_status, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(l_mode, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(l_file, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                                .addGap(118, 118, 118)
                                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                    .addComponent(l_tot_count, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                    .addComponent(l_totl_lost, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(lab_tot_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addComponent(lab_tot_count, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                            .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(lab_mode, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addComponent(lab_status, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(l_rate)
                                            .addComponent(l_avg))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_rate, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(lab_avg, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addComponent(lab_file, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel20)
                                    .addComponent(jLabel27))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_c11_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel17))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_c14_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel53))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel52)
                                            .addComponent(lab_s22_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                        .addComponent(lab_c11_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(lab_c14_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(lab_s22_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(18, 18, 18)
                                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                        .addComponent(lab_hvg_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(lab_vlg_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(lab_hk_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(lab_not_lost, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_hvg_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel48))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_vlg_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel55))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(lab_hk_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jLabel54))
                                        .addGap(18, 18, 18)
                                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel56)
                                            .addComponent(lab_not_count, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE))))))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(runningObservationPaneLayout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 700, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        runningObservationPaneLayout.setVerticalGroup(
            runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, runningObservationPaneLayout.createSequentialGroup()
                .addGap(13, 13, 13)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_status)
                    .addComponent(lab_status)
                    .addComponent(l_tot_count)
                    .addComponent(lab_tot_count)
                    .addComponent(l_rate)
                    .addComponent(lab_rate))
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                        .addGap(25, 25, 25)
                        .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(l_mode)
                            .addComponent(lab_mode)
                            .addComponent(l_totl_lost)
                            .addComponent(lab_tot_lost)
                            .addComponent(l_avg)))
                    .addGroup(runningObservationPaneLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(lab_avg)))
                .addGap(26, 26, 26)
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lab_file)
                    .addComponent(l_file))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 3, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel52)
                    .addComponent(jLabel53)
                    .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel55)
                    .addComponent(jLabel54)
                    .addComponent(jLabel56)
                    .addComponent(jLabel48))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel27)
                    .addComponent(lab_c11_count)
                    .addComponent(lab_s22_count)
                    .addComponent(lab_vlg_count)
                    .addComponent(lab_hk_count)
                    .addComponent(lab_not_count)
                    .addComponent(lab_c14_count)
                    .addComponent(lab_hvg_count))
                .addGap(18, 18, 18)
                .addGroup(runningObservationPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel20)
                    .addComponent(lab_c11_lost)
                    .addComponent(lab_c14_lost)
                    .addComponent(lab_vlg_lost)
                    .addComponent(lab_hvg_lost)
                    .addComponent(lab_s22_lost)
                    .addComponent(lab_hk_lost)
                    .addComponent(lab_not_lost))
                .addGap(85, 85, 85))
        );

        Logo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        Logo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/LogoINAFOAS.png"))); // NOI18N
        Logo.setMaximumSize(null);
        Logo.setMinimumSize(null);
        Logo.setPreferredSize(null);

        javax.swing.GroupLayout jPanelLayout = new javax.swing.GroupLayout(jPanel);
        jPanel.setLayout(jPanelLayout);
        jPanelLayout.setHorizontalGroup(
            jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelLayout.createSequentialGroup()
                        .addComponent(projectConfigurationPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(observationConfigurationPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(Logo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(commandsPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(runningObservationPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanelLayout.setVerticalGroup(
            jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLayout.createSequentialGroup()
                .addComponent(Logo, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(observationConfigurationPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(projectConfigurationPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(commandsPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(runningObservationPane, javax.swing.GroupLayout.PREFERRED_SIZE, 314, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(27, Short.MAX_VALUE))
        );

        jScrollPane.setViewportView(jPanel);

        getContentPane().add(jScrollPane, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void b_stop_allActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_stop_allActionPerformed
        if ( instancesOfProcess("BIAS.lnx") > 0 ){
            stopXtermProcess("BIAS.lnx");
        }
    }//GEN-LAST:event_b_stop_allActionPerformed

    private void b_start_allActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_start_allActionPerformed
        if ( instancesOfProcess("BIAS.lnx") == 0 ){
            startBIASProcess();
        }
    }//GEN-LAST:event_b_start_allActionPerformed

    private void b_start_daqActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_start_daqActionPerformed
        if ( instancesOfProcess("AstriDAQ.lnx") == 0 ){
            startDAQProcess();
        }
    }//GEN-LAST:event_b_start_daqActionPerformed

    private void b_stop_daqActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_stop_daqActionPerformed
        if ( instancesOfProcess("AstriDAQ.lnx") > 0 ){
            stopXtermProcess("AstriDAQ.lnx");
        }
    }//GEN-LAST:event_b_stop_daqActionPerformed

    private void b_start_procActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_start_procActionPerformed
        if ( instancesOfProcess("AstriMaProcesso") == 0 ){ // process name is limitet do 15 chars.
            startPROCProcess();
        }
    }//GEN-LAST:event_b_start_procActionPerformed

    private void b_stop_procActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_stop_procActionPerformed
        if ( instancesOfProcess("AstriMaProcesso") > 0 ){  // process name is limitet do 15 chars.
            stopXtermProcess("AstriMaProcesso");    }//GEN-LAST:event_b_stop_procActionPerformed
    }
    private void b_set_configurationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_set_configurationActionPerformed
        String date = val_date.getText();
        String targetid = val_targetid.getText();
        String obs_mode = val_obsmode.getText();
        String telid = val_telid.getText();
        String runid = val_runid.getText();

        if (!date.isEmpty() ) myDB.SetActiveData("schedulingblock_config", "date", date);
        if (!targetid.isEmpty()) myDB.SetActiveData("schedulingblock_config", "target_id", targetid);
        if (!obs_mode.isEmpty()) myDB.SetActiveData("schedulingblock_config", "obs_mode", obs_mode);
        if (!telid.isEmpty()) myDB.SetActiveData("schedulingblock_config", "tel_id", telid);
        if (!runid.isEmpty()) myDB.SetActiveData("schedulingblock_config", "run_id", runid);

        val_date.setText("");
        val_targetid.setText("");
        val_obsmode.setText("");
        val_telid.setText("");
        val_runid.setText("");
    }//GEN-LAST:event_b_set_configurationActionPerformed

    private void val_dateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_val_dateActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_val_dateActionPerformed

    private void b_set_daqidActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_b_set_daqidActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_b_set_daqidActionPerformed

    private void val_daq_idActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_val_daq_idActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_val_daq_idActionPerformed

    private void lab_daq_iddaq_id_initialize(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_lab_daq_iddaq_id_initialize
        // TODO add your handling code here:
    }//GEN-LAST:event_lab_daq_iddaq_id_initialize

    private void startDAQProcess() {
        String daqLogsPath = System.getenv("BIAS_PREFIX") + "/logs/AstriDAQ/";
        final String daqExecutable = System.getenv("BIAS_PREFIX") + "/bin/AstriDAQ.lnx";

        // Create the log directory if does not exist
        File logsPath = new File(daqLogsPath);
        if (!logsPath.exists())
            logsPath.mkdirs();

        // Create logFile with current date:
        LocalDateTime currentDateTime = LocalDateTime.now();
        String a_logfile = currentDateTime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd_HH-mm-ss"));
        a_logfile += ".txt";
        final String logfile = logsPath.toPath().toString() + "/" + a_logfile;

        Thread xtermThread = new Thread(() -> {
            try {
                final String cmd =  daqExecutable + " 2>&1 | tee " +  logfile;
                // Command to start xterm and execute your command within a shell
                String[] command = {"xterm", "-e", "sh", "-c", cmd};
                // Create a process builder
                ProcessBuilder processBuilder = new ProcessBuilder(command);
                // Start the process
                 xtermProcess = processBuilder.start();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
        // Start the Xterm thread
        xtermThread.start();
    }
    
    
    private void startPROCProcess() {
        String procLogsPath = System.getenv("BIAS_PREFIX") + "/logs/AstriMaProcessor/";
        final String procexecutable = System.getenv("BIAS_PREFIX") + "/bin/AstriMaProcessor.lnx";

        // Create the log directory if does not exist
        File logsPath = new File(procLogsPath);
        if (!logsPath.exists())
            logsPath.mkdirs();

        // Create logFile with current date:
        LocalDateTime currentDateTime = LocalDateTime.now();
        String a_logfile = currentDateTime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd_HH-mm-ss"));
        a_logfile += ".txt";
        final String logfile = logsPath.toPath().toString() + "/" + a_logfile;

        Thread xtermThread = new Thread(() -> {
            try {
                final String cmd =  procexecutable + " 2>&1 | tee " +  logfile;
                // Command to start xterm and execute your command within a shell
                String[] command = {"xterm", "-e", "sh", "-c", cmd};
                // Create a process builder
                ProcessBuilder processBuilder = new ProcessBuilder(command);

                // Start the process
                 xtermProcess = processBuilder.start();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
        // Start the Xterm thread
        xtermThread.start();
    }
        
        
    private void startBIASProcess() {
        String biasLogsPath = System.getenv("BIAS_PREFIX") + "/logs/BIAS/";
        final String biasxecutable = System.getenv("BIAS_PREFIX") + "/bin/BIAS.lnx";

        // Create the log directory if does not exist
        File logsPath = new File(biasLogsPath);
        if (!logsPath.exists())
            logsPath.mkdirs();

        // Create logFile with current date:
        LocalDateTime currentDateTime = LocalDateTime.now();
        String a_logfile = currentDateTime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd_HH-mm-ss"));
        a_logfile += ".txt";
        final String logfile = logsPath.toPath().toString() + "/" + a_logfile;

        Thread xtermThread = new Thread(() -> {
            try {
                final String cmd =  biasxecutable + " 2>&1 | tee " +  logfile;
                // Command to start xterm and execute your command within a shell
                String[] command = {"xterm", "-e", "sh", "-c", cmd};
                // Create a process builder
                ProcessBuilder processBuilder = new ProcessBuilder(command);

                // Start the process
                 xtermProcess = processBuilder.start();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
        // Start the Xterm thread
        xtermThread.start();
    }
    
    private int instancesOfProcess(String processName) {
         
        int instances = 0; 
          
        try {
            // Build and execute the shell command to check the number of running processes
            String command = "pgrep -c " + processName;
            Process process = Runtime.getRuntime().exec(command);

            try ( // Read the process count from the command output
                    BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()))) {
                String line = reader.readLine();
                
                if (line != null) {
                    instances = Integer.parseInt(line.trim());
                    
                }
            }
            process.waitFor();
        } catch (IOException | InterruptedException e) {
        }
        return instances;
      }






    
    private void stopXtermProcess(String processName) {
        try {
            // Build and execute the shell command to kill processes by name
            String command = "pkill " + processName;
            Process process = Runtime.getRuntime().exec(command);

            // Wait for the process to complete
            int exitCode = process.waitFor();

            if (exitCode == 0) {
                System.out.println("Successfully killed processes with name: " + processName);
            } else {
                System.err.println("Failed to kill processes with name: " + processName);
            }
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }
    
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {


        java.awt.EventQueue.invokeLater(() -> {
            new MainFrame().setVisible(true);
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Logo;
    private javax.swing.JButton b_set_configuration;
    private javax.swing.JButton b_set_daqid;
    private javax.swing.JButton b_start_all;
    private javax.swing.JButton b_start_daq;
    private javax.swing.JButton b_start_proc;
    private javax.swing.JButton b_stop_all;
    private javax.swing.JButton b_stop_daq;
    private javax.swing.JButton b_stop_proc;
    private javax.swing.JPanel commandsPane;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel;
    private javax.swing.JScrollPane jScrollPane;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JLabel l_archiver;
    private javax.swing.JLabel l_avg;
    private javax.swing.JLabel l_date;
    private javax.swing.JLabel l_file;
    private javax.swing.JLabel l_mode;
    private javax.swing.JLabel l_monitor;
    private javax.swing.JLabel l_obsmode;
    private javax.swing.JLabel l_packet;
    private javax.swing.JLabel l_protocol;
    private javax.swing.JLabel l_provider;
    private javax.swing.JLabel l_rate;
    private javax.swing.JLabel l_rate_interval;
    private javax.swing.JLabel l_status;
    private javax.swing.JLabel l_targetid;
    private javax.swing.JLabel l_telid;
    private javax.swing.JLabel l_tot_count;
    private javax.swing.JLabel l_totl_lost;
    private javax.swing.JLabel lab_archiver;
    private javax.swing.JLabel lab_avg;
    private javax.swing.JLabel lab_c11_count;
    private javax.swing.JLabel lab_c11_lost;
    private javax.swing.JLabel lab_c14_count;
    private javax.swing.JLabel lab_c14_lost;
    public javax.swing.JLabel lab_daq_id;
    private javax.swing.JLabel lab_date;
    private javax.swing.JLabel lab_file;
    private javax.swing.JLabel lab_hk_count;
    private javax.swing.JLabel lab_hk_lost;
    private javax.swing.JLabel lab_hvg_count;
    private javax.swing.JLabel lab_hvg_lost;
    private javax.swing.JLabel lab_mode;
    private javax.swing.JLabel lab_monitor;
    private javax.swing.JLabel lab_not_count;
    private javax.swing.JLabel lab_not_lost;
    private javax.swing.JLabel lab_obsmode;
    private javax.swing.JLabel lab_packet;
    private javax.swing.JLabel lab_protocol;
    private javax.swing.JLabel lab_provider;
    private javax.swing.JLabel lab_rate;
    private javax.swing.JLabel lab_rateinterval;
    private javax.swing.JLabel lab_runid;
    private javax.swing.JLabel lab_s22_count;
    private javax.swing.JLabel lab_s22_lost;
    private javax.swing.JLabel lab_status;
    private javax.swing.JLabel lab_targetid;
    private javax.swing.JLabel lab_telid;
    private javax.swing.JLabel lab_tot_count;
    private javax.swing.JLabel lab_tot_lost;
    private javax.swing.JLabel lab_vlg_count;
    private javax.swing.JLabel lab_vlg_lost;
    private javax.swing.JPanel observationConfigurationPane1;
    private javax.swing.JPanel projectConfigurationPane;
    private javax.swing.JLabel r_runid;
    private javax.swing.JPanel runningObservationPane;
    private javax.swing.JTextField val_daq_id;
    private javax.swing.JTextField val_date;
    private javax.swing.JTextField val_obsmode;
    private javax.swing.JTextField val_runid;
    private javax.swing.JTextField val_targetid;
    private javax.swing.JTextField val_telid;
    // End of variables declaration//GEN-END:variables


    
    

        
    private void setCurrentDaqID(String text) throws IOException {
           
            // connect MySql DB
            try {
                  myDB.SetActiveData("astridaq_config", "daq_id", text);

            } catch (Exception e) {
            }
            

    }

    
    private void initialize() {

        // connect Redis DB 
        myRedis = new Redis();
            
        
        // connect MySql DB
        try {
             myDB = new db();
        
        } catch (Exception e) {
        }
       
        // initialize archiving parameters
        String[] archive_config = myDB.getArchiveConfig(); 
        if (archive_config.length > 0){
            archiveActive = true;
            host = archive_config[0];
            username =archive_config[1];
            password = archive_config[2];
            remote_path = archive_config[3]; 
            port = archive_config[4];
            connection = archive_config[5]; //FTP / SSH 
        }else {
            archiveActive = false;           
        }

             // start monitoring
        Timer monitor = new Timer();
        monitor.schedule(new UpdateMon(), 0, 1000); // Update every second
    }

 

    

    private class UpdateMon extends TimerTask {
        @Override
        @SuppressWarnings("static-access")
        public void run() {
            // to get from mysql
            lab_daq_id.setText(myDB.getData("astridaq_config", "daq_id"));
            lab_protocol.setText(myDB.getData("astridaq_config", "protocol"));
            lab_archiver.setText(myDB.getData("astridaq_config", "archiver"));
            lab_provider.setText(myDB.getData("astridaq_config", "provider"));
            lab_packet.setText(myDB.getData("astridaq_config", "packet"));
            lab_monitor.setText(myDB.getData("astridaq_config", "monitor"));
            lab_rateinterval.setText(myDB.getData("astrisimplemonitor_config", "rateinterval"));
            
            lab_date.setText(myDB.getData("schedulingblock_config", "date"));
            lab_targetid.setText(myDB.getData("schedulingblock_config", "target_id"));
            lab_obsmode.setText(myDB.getData("schedulingblock_config", "obs_mode"));
            lab_telid.setText(myDB.getData("schedulingblock_config", "tel_id"));
            lab_runid.setText(myDB.getData("schedulingblock_config", "run_id"));        

            
            //to get from redis
            String mode = myRedis.getValue("daq_mode"); 
            lab_mode.setText(mode);
            lab_status.setText(myRedis.getValue("receiver_connection"));
            
            String last_open_file_abs = myRedis.getValue("last_open_file"); 
            String[] parts = last_open_file_abs.split("/");
            String last_filename = parts[parts.length - 1];
            lab_file.setText(last_filename);
            
            // packet details
            lab_tot_count.setText(myRedis.getValue("tot_packets"));
            lab_tot_lost.setText(myRedis.getValue("tot_lost"));

            
            String byte_rate = myRedis.getValue("mbit_rate");
            double byte_rate_double; 
            if (!byte_rate.isEmpty()){
                   byte_rate_double = Double.parseDouble(byte_rate);
            }else {
                byte_rate_double = 0; 
            }
            String byte_rate_rounded = Long.toString(Math.round(byte_rate_double));
            lab_rate.setText(byte_rate_rounded);
            
            
            String packet_rate = myRedis.getValue("packet_rate");
            double packet_rate_double = Double.parseDouble(packet_rate);
            String packet_rate_rounded = Long.toString(Math.round(packet_rate_double));
            lab_avg.setText(packet_rate_rounded);

            lab_c11_count.setText(myRedis.getValue("11_tot"));
            lab_c11_lost.setText(myRedis.getValue("11_lost"));
            
            lab_c14_count.setText(myRedis.getValue("14_tot"));
            lab_c14_lost.setText(myRedis.getValue("14_lost"));
            
            lab_s22_count.setText(myRedis.getValue("22_tot"));
            lab_s22_lost.setText(myRedis.getValue("22_lost"));

            lab_hvg_count.setText(myRedis.getValue("102_tot"));
            lab_hvg_lost.setText(myRedis.getValue("102_lost"));
            
            lab_vlg_count.setText(myRedis.getValue("103_tot"));
            lab_vlg_lost.setText(myRedis.getValue("103_lost"));
            
            lab_hk_count.setText(myRedis.getValue("101_tot"));
            lab_hk_lost.setText(myRedis.getValue("101_lost"));
            
            lab_not_count.setText(myRedis.getValue("151_tot"));
            lab_not_lost.setText(myRedis.getValue("151_lost"));
            
            

            
            
            
            if (archiveActive == true){                
                try { 
                    performDelivery();
                } catch (SQLException ex) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                }
                
            }
        }

        private void performDelivery() throws SQLException {


            ExecutorService executorService = Executors.newFixedThreadPool(5); // Adjust the number of threads as needed

            String[] fileNames = myDB.fetchFileNames();
            
            // Process the file names here
            for (String fileName : fileNames) {
                //System.out.println("File Name: " + fileName);
                
                //update sent = 1 (in progress)
                
                    // Submit the file upload task to the executor
                    String cleanfile = expandEnvVariablesInPath(fileName);
                    System.out.println("file pulito " + cleanfile);
                    transferFileToCentralServer(cleanfile);               
                
                    
                    // update sent = 2 (completed) 
            }

            // Shutdown the executor when you're done
            executorService.shutdown();
         
         
        }
    }

    
public String expandEnvVariablesInPath(String path) {
    
   
        
        String regex = "\\$([^/]+)";
        
        // Use a Matcher to find and replace environment variables
        Matcher matcher = Pattern.compile(regex).matcher(path);
        StringBuffer result = new StringBuffer();
        
        while (matcher.find()) {
            String envVariableName = matcher.group(1);
            String envVariableValue = System.getenv(envVariableName);
            
            if (envVariableValue != null) {
                // Replace the matched environment variable with its value
                matcher.appendReplacement(result, envVariableValue);
            }
        }
        
        // Append the remaining part of the input string
        matcher.appendTail(result);
        
        return result.toString();
    }
    
        private void transferFileToCentralServer(String filestring) {

            File file = new File(filestring);
            
            if ("ftp".equals(connection)){
                FTPClient ftpClient = new FTPClient();
              

                try  {
                       ftpClient.connect(host,  Integer.parseInt(port));
                       ftpClient.login(username, password);
                       ftpClient.enterLocalPassiveMode();
                       ftpClient.setFileType(FTP.BINARY_FILE_TYPE);

                       // Upload the local file to the FTP server
                       boolean success = ftpClient.storeFile(remote_path + "/" +  file.getName(), new FileInputStream(file));
                       int replyCode = ftpClient.getReplyCode();


                       if (success) {
                           System.out.println("File uploaded successfully.");
                       } else {
                           System.out.println("File upload failed.");
                       }

                       ftpClient.logout();
                   } catch (IOException e) {
                       e.printStackTrace();
                   }
            
            } // end for ftp connection
    }
    
    

    
    
}
