package com.mycompany.controlpanelmvn;

/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

/**
 *
 * @author conforti
 */

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

public class db {

    Configuration config = new Configuration();

    private String nomeDB = config.getDBname(); // "dpsdb"; // Nome del Database a cui connettersi
    private String nomeUtente = config.getDBuser(); // "root"; // Nome utente utilizzato per la connessione al Database
    private String pwdUtente = config.getDBpwd(); // "MYSQL01cst01"; // password dell'utente del db
    // "MYSQL01cst01"; // password dell'utente del db
    private Connection db;
    // Flag che indica se la connessione è attiva o meno
    // La connessione col Database
    private boolean connesso;

    // measure configuration table names
    private static final String PIDTABLE = "plan";
    private static final String SIDTABLE = "session";
    private static final String BIDTABLE = "measureblock";

    // DB connection
    public db() {
        this.connesso = false;
        // Carico il driver JDBC per la connessione con il database MySQL
        /*try{
			Class.forName("com.mysql.jdbc.Driver");	
		}catch (ClassNotFoundException e) {
			System.err.println("[ERRORE]");
			System.err.println(e.getMessage());
		}*/

        try {

            // connection with password
            this.db = DriverManager.getConnection("jdbc:mysql://localhost/" + nomeDB + "?user=" + nomeUtente + "&password=" + pwdUtente);

            this.connesso = true;

        } catch (SQLException e) {
            System.err.println("[Connection to mysql server error]");
            System.err.println(e.getMessage());

        }
    }

    public void disconnect() {

        try {
            this.db.close();
        } catch (SQLException e) {
            System.err.println("[ERRORE]");
        }
    }

    // mostra i risultati della query di esempio
    public void showResultSet() throws SQLException {
        if (this.connesso == true) {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            try {
                result = statement.executeQuery("SELECT * FROM camera WHERE event_id = 301");

                ResultSetMetaData meta = result.getMetaData();
                int numColonne = meta.getColumnCount();

                for (int i = 1; i <= numColonne; i++) {
                    System.out.print(meta.getColumnLabel(i) + " | ");
                }

                System.out.println("");

                while (result.next()) {

                    for (int i = 1; i <= numColonne; i++) {

                        System.out.print(result.getString(i) + " | ");
                    }
                    System.out.println("");
                }

                System.out.println("number of columns = " + numColonne);
            } catch (SQLException e) {
                System.err.print("[ERRORE]");
                System.err.println(e.getMessage());
            }
            if (statement != null) statement.close();
            if (result != null) result.close();
        } else {

            System.out.print("[WARNING]Data base non connesso ");

        }
    }

    // CONFIGURATION QUERY 
    /*
     * 
     *    
     */
    public String getConfig(String item) {

        String table = "";
        String configItem = "";

        if ("pid".equals(item)) table = PIDTABLE;
        if ("sid".equals(item)) table = SIDTABLE;
        if ("bid".equals(item)) table = BIDTABLE;

        if ("".equals(table)) {
            System.out.print("[SW DEVELOPMEMT ERROR] it is called the getConfig passing unknown config type");
        }

        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT name FROM `" + table + "` WHERE active = 1");
            int rows = 0;
            while (result.next()) {
                configItem = result.getString(1);
                rows++;
            }
            if (rows > 1) System.out.println("[WARNING] Too many config item active !!");
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return configItem;

    }

    public void clearConfig() {
        try {
            Statement istruzione = this.db.createStatement();
            istruzione.executeUpdate("UPDATE  `" + PIDTABLE + "` SET active = 0 WHERE active = 1");
            istruzione.executeUpdate("UPDATE  `" + SIDTABLE + "` SET active = 0 WHERE active = 1");
            istruzione.executeUpdate("UPDATE  `" + BIDTABLE + "` SET active = 0 WHERE active = 1");
            if (istruzione != null) istruzione.close();

        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }
    }

    public void setConfig(String pid, String sid, String bid) {

        // clear old config
        this.clearConfig();

        try {
            Statement queryStatement = this.db.createStatement();
            ResultSet result = null;
            //pid 
            result = queryStatement.executeQuery("SELECT count(*) FROM plan WHERE pid = '" + pid + "'");
            while (result.next()) {
                int count_pid = Integer.parseInt(result.getString(1));
                if (count_pid == 0) {
                    // insert new pid and active
                    queryStatement.executeUpdate("INSERT INTO " + PIDTABLE + " (pid, name, active) VALUES( '" + pid + "' ,  '" + pid + "' ,  '1' )  ");
                } else {
                    // active existing pid
                    queryStatement.executeUpdate("UPDATE " + PIDTABLE + " SET active = 1 WHERE pid =  '" + pid + "' ");
                }
            }

            // sid 
            result = queryStatement.executeQuery("SELECT count(*) FROM session WHERE sid = '" + sid + "' AND pid = '" + pid + "' ");
            while (result.next()) {
                int count_sid = Integer.parseInt(result.getString(1));
                if (count_sid == 0) {
                    // insert new pid and active
                    queryStatement.executeUpdate("INSERT INTO " + SIDTABLE + " (sid, pid,  name, active) VALUES( '" + sid + "' , '" + pid + "' ,   '" + sid + "' ,  '1' )  ");
                } else {
                    // active existing pid
                    queryStatement.executeUpdate("UPDATE " + SIDTABLE + " SET active = 1 WHERE pid =  '" + pid + "' AND sid = '" + sid + "' ");
                }
            }

            // bid
            result = queryStatement.executeQuery("SELECT count(*) FROM measureblock WHERE bid = '" + bid + "' AND sid = '" + sid + "' AND pid = '" + pid + "' ");
            while (result.next()) {
                int count_bid = Integer.parseInt(result.getString(1));
                if (count_bid == 0) {
                    // insert new pid and active
                    queryStatement.executeUpdate("INSERT INTO " + BIDTABLE + " (bid, sid, pid,  name, active) VALUES('" + bid + "' ,  '" + sid + "' , '" + pid + "' ,   '" + bid + "' ,  '1' )  ");
                } else {
                    // active existing pid
                    queryStatement.executeUpdate("UPDATE " + BIDTABLE + " SET active = 1 WHERE pid =  '" + pid + "' AND sid = '" + sid + "' AND bid = '" + bid + "' ");
                }
            }
            if (queryStatement != null) queryStatement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

    }

    public String getRunIdFile() {
        String runItem = "";


        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT discos_conf FROM iw_baseconf WHERE id = 1");
            int rows = 0;
            while (result.next()) {
                runItem = result.getString(1);
                rows++;
            }
            if (rows > 1) System.out.println("[WARNING] Too many run_id_file active !!");
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return runItem;
    }

    public String getLastRunId() {
        String last_run_id = "";

        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT MAX(runid) FROM measure");
            int rows = 0;
            while (result.next()) {
                last_run_id = result.getString(1);
                rows++;
            }
            if (rows > 1) System.out.println("[WARNING] Too many max run!!");
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return last_run_id;
    }

    public boolean fileExists(String filename) {

        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT * FROM file WHERE filename ='" + filename + "'");
            int rows = 0;
            while (result.next()) {
                rows++;
            }
            if (rows >= 1)
                if (statement != null) statement.close();
            if (result != null) result.close();
            return true;
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return false;
    }

    String getCurrentRUNID() {

        String current_run_id = "";
        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT daq_id FROM astridaq_config where active = 1");
            int rows = 0;
            while (result.next()) {
                current_run_id = result.getString(1);
                rows++;
            }
            if (rows > 1) System.out.println("[WARNING] Too many max run!!");
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return current_run_id;

    }

    void SetActiveData(String table, String column, String text) {

        try {
            Statement statement = this.db.createStatement();
            statement.executeUpdate("UPDATE  " + table + " SET " + column + " = '" + text + "' WHERE active = 1");
            if (statement != null) statement.close();
        } catch (SQLException e) {
            System.err.println("[Error in SET ACTIVE DATA]");
            System.err.println(e.getMessage());
        }

    }

    String getData(String table, String column) {

        String current_run_id = "";

        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT " + column + " FROM " + table + " where active = 1");
            int rows = 0;
            while (result.next()) {
                current_run_id = result.getString(1);
                rows++;
            }
            if (rows > 1) System.out.println("[WARNING] Too many max run!!");
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }
        return current_run_id;

    }

    public String[] fetchFileNames() throws SQLException {
        List < String > fileNames = new ArrayList < > ();

        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT folder, name FROM acquired_files WHERE sent = 0");

            while (result.next()) {
                String fileName = result.getString("name");
                String path = result.getString("folder");
                fileNames.add(path + "/" + fileName);
            }
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }

        return fileNames.toArray(new String[0]);
    }

    String[] getArchiveConfig() {

        List < String > params = new ArrayList < > ();
        try {
            Statement statement = this.db.createStatement();
            ResultSet result = null;
            result = statement.executeQuery("SELECT * FROM archiving_config WHERE active = 1");

            while (result.next()) {
                params.add(result.getString("host"));
                params.add(result.getString("username"));
                params.add(result.getString("password"));
                params.add(result.getString("remote_path"));
                params.add(result.getString("port"));
                params.add(result.getString("connection"));

            }
            if (statement != null) statement.close();
            if (result != null) result.close();
        } catch (SQLException e) {
            System.err.print("[ERRORE]");
            System.err.println(e.getMessage());
        }
        return params.toArray(new String[0]);

    }

}
